/* $Id: creature-detail.c,v 1.51 2010/03/12 06:41:29 oohara Exp $ */

#include <stdio.h>
/* rand */
#include <stdlib.h>

#include "util.h"

#include "creature-detail.h"

int
creature_detail_get(int type, struct creature_detail *crd)
{
  if (crd == NULL)
  {
    fprintf(stderr, "creature_detail_get: crd is NULL\n");
    return 1;
  }

  (*crd).type = type;
  switch (type)
  {
  case CR_PLAYER:
    (*crd).name = "player";
    (*crd).symbol = "@";
    (*crd).warning = "0";
    (*crd).description = "It can use shadows.";
    (*crd).max_hp = 18;
    (*crd).power_melee = 7;
    (*crd).power_missile = 5;
    break;
  case CR_PLAYER_SHADOW:
    (*crd).name = "player shadow";
    (*crd).symbol = "&";
    (*crd).warning = "0";
    (*crd).description = "It is friendly.";
    (*crd).max_hp = 18;
    (*crd).power_melee = 7;
    (*crd).power_missile = 5;
    break;
  case CR_GOBLIN:
    (*crd).name = "goblin";
    (*crd).symbol = "g";
    (*crd).warning = "1";
    (*crd).description = "(Although it is weak, it can do a missile attack.)";
    (*crd).max_hp = 3;
    (*crd).power_melee = 3;
    (*crd).power_missile = 2;
    break;
  case CR_RAT:
    (*crd).name = "rat";
    (*crd).symbol = "r";
    (*crd).warning = "1";
    (*crd).description = "(It is the weakest monster in this game.)";
    (*crd).max_hp = 2;
    (*crd).power_melee = 4;
    (*crd).power_missile = 0;
    break;
  case CR_SORCERER:
    (*crd).name = "sorcerer";
    (*crd).symbol = "s";
    (*crd).warning = "4";
    (*crd).description = "(It is the master of a missile attack.)";
    (*crd).max_hp = 6;
    (*crd).power_melee = 2;
    (*crd).power_missile = 12;
    break;
  case CR_DISENCHANTER:
    (*crd).name = "disenchanter";
    (*crd).symbol = "q";
    (*crd).warning = "5";
    (*crd).description = "If its attack hits, it adds "
      "(2) antimagic to the target.\n"
      "An attack to it doesn't hit if the attacker has an enchantment.";
    (*crd).max_hp = 10;
    (*crd).power_melee = 4;
    (*crd).power_missile = 3;
    break;
  case CR_DRAGON:
    (*crd).name = "dragon";
    (*crd).symbol = "d";
    (*crd).warning = "5";
    (*crd).description = "If stays if it is not damaged.";
    (*crd).max_hp = 24;
    (*crd).power_melee = 9;
    (*crd).power_missile = 9;
    break;
  case CR_MOLD:
    (*crd).name = "mold";
    (*crd).symbol = "m";
    (*crd).warning = "1";
    (*crd).description = "Walking doesn't move it to a different location.\n"
      "(It can still attack.)";
    (*crd).max_hp = 10;
    (*crd).power_melee = 5;
    (*crd).power_missile = 0;
    break;
  case CR_WARLORD:
    (*crd).name = "warlord";
    (*crd).symbol = "w";
    (*crd).warning = "4";
    (*crd).description = "When it attacks, it does both a melee attack and "
      "a missile attack.\n"
    "It does a melee attack first.";
    (*crd).max_hp = 10;
    (*crd).power_melee = 4;
    (*crd).power_missile = 3;
    break;
  case CR_OGRE:
    (*crd).name = "ogre";
    (*crd).symbol = "o";
    (*crd).warning = "2";
    (*crd).description = "(Its melee attack hurts.)";
    (*crd).max_hp = 7;
    (*crd).power_melee = 9;
    (*crd).power_missile = 0;
    break;
  case CR_TURRET:
    (*crd).name = "turret";
    (*crd).symbol = "z";
    (*crd).warning = "3";
    (*crd).description = "Walking doesn't move it to a different location.\n"
      "(It can still attack.)\n"
      "When it attacks, it does a missile attack.";
    (*crd).max_hp = 7;
    (*crd).power_melee = 0;
    (*crd).power_missile = 6;
    break;
  case CR_CRYSTAL_FLOWER:
    (*crd).name = "crystal flower";
    (*crd).symbol = "c";
    (*crd).warning = "4";
    (*crd).description = "Walking doesn't move it to a different location.\n"
      "(It can still attack.)\n"
      "If a missile attack hits it, the attacker takes "
      "the damage of the attack\n"
      "instead of it.";
    (*crd).max_hp = 8;
    (*crd).power_melee = 5;
    (*crd).power_missile = 0;
    break;
  case CR_ARCHER:
    (*crd).name = "archer";
    (*crd).symbol = "a";
    (*crd).warning = "2";
    (*crd).description = "(It can't do a melee attack.)";
    (*crd).max_hp = 7;
    (*crd).power_melee = 0;
    (*crd).power_missile = 7;
    break;
  case CR_JELLY:
    (*crd).name = "jelly";
    (*crd).symbol = "j";
    (*crd).warning = "3";
    (*crd).description = "If its melee attack hits, it adds "
      "(2) poison to the target.";
    (*crd).max_hp = 9;
    (*crd).power_melee = 1;
    (*crd).power_missile = 0;
    break;
  case CR_IRON_GOLEM:
    (*crd).name = "iron golem";
    (*crd).symbol = "i";
    (*crd).warning = "3";
    (*crd).description = "Its action takes twice time as usual.\n"
      "If its melee attack hits, it adds "
      "(4) stun to the target.";
    (*crd).max_hp = 13;
    (*crd).power_melee = 9;
    (*crd).power_missile = 3;
    break;
  case CR_BERSERKER:
    (*crd).name = "berserker";
    (*crd).symbol = "b";
    (*crd).warning = "2";
    (*crd).description = "If it is damaged, it gets (3) fast.";
    (*crd).max_hp = 8;
    (*crd).power_melee = 4;
    (*crd).power_missile = 3;
    break;
  default:
    (*crd).name = "undefined creature";
    (*crd).symbol = "X";
    (*crd).warning = "9";
    (*crd).description = "It indicates this game has a bug.";
    (*crd).max_hp = 99;
    (*crd).power_melee = 0;
    (*crd).power_missile = 0;
    return 1;
    break;
  }

  return 0;
}

int
random_creature_type(int z)
{
  int type;

  if (z < 3)
  {
    switch (rand() % 4)
    {
    case 0:
    case 1:
      type = CR_RAT;
      break;
    case 2:
      type = CR_GOBLIN;
      break;
    default:
      type = CR_MOLD;
      break;
    }
  }
  else if (z < 5)
  {
    switch (rand() % 8)
    {
    case 0:
    case 1:
      type = CR_ARCHER;
      break;
    case 2:
    case 3:
      type = CR_OGRE;
      break;
    case 4:
    case 5:
      type = CR_BERSERKER;
      break;
    case 6:
      type = CR_GOBLIN;
      break;
    default:
      type = CR_MOLD;
      break;
    }
  }
  else if (z < 7)
  {
    switch (rand() % 8)
    {
    case 0:
    case 1:
      type = CR_IRON_GOLEM;
      break;
    case 2:
    case 3:
      type = CR_TURRET;
      break;
    case 4:
    case 5:
      type = CR_JELLY;
      break;
    case 6:
      type = CR_OGRE;
      break;
    case 7:
      type = CR_ARCHER;
      break;
    default:
      type = CR_BERSERKER;
      break;
    }
  }
  else if (z < 9)
  {
    switch (rand() % 11)
    {
    case 0:
    case 1:
      type = CR_IRON_GOLEM;
      break;
    case 2:
    case 3:
      type = CR_TURRET;
      break;
    case 4:
    case 5:
      type = CR_JELLY;
      break;
    case 6:
      type = CR_OGRE;
      break;
    case 7:
      type = CR_BERSERKER;
      break;
    case 8:
      type = CR_SORCERER;
      break;
    case 9:
      type = CR_WARLORD;
      break;
    default:
      type = CR_CRYSTAL_FLOWER;
      break;
    }
  }
  else if (z < 11)
  {
    switch (rand() % 11)
    {
    case 0:
    case 1:
      type = CR_IRON_GOLEM;
      break;
    case 2:
    case 3:
      type = CR_TURRET;
      break;
    case 4:
    case 5:
      type = CR_JELLY;
      break;
    case 6:
      type = CR_SORCERER;
      break;
    case 7:
      type = CR_WARLORD;
      break;
    case 8:
      type = CR_CRYSTAL_FLOWER;
      break;
    case 9:
      type = CR_DRAGON;
      break;
    default:
      type = CR_DISENCHANTER;
      break;
    }
  }
  else
  {
    switch (rand() % 11)
    {
    case 0:
      type = CR_IRON_GOLEM;
      break;
    case 1:
      type = CR_TURRET;
      break;
    case 2:
      type = CR_JELLY;
      break;
    case 3:
    case 4:
      type = CR_SORCERER;
      break;
    case 5:
    case 6:
      type = CR_WARLORD;
      break;
    case 7:
      type = CR_CRYSTAL_FLOWER;
      break;
    case 8:
    case 9:
      type = CR_DRAGON;
      break;
    default:
      type = CR_DISENCHANTER;
      break;
    }
  }

  return type;
}

