/* $Id: creature.c,v 1.13 2010/03/09 22:17:57 oohara Exp $ */

#include <stdio.h>
/* malloc */
#include <stdlib.h>

#include "creature.h"

creature *
creature_new(void)
{
  int i;
  creature *p = NULL;

  p = (creature *) malloc(sizeof(creature));
  if (p == NULL)
  {
    fprintf(stderr, "creature_new: malloc(p) failed\n");
    return NULL;
  }

  p->id = -1;
  p->type = -1;
  p->z = -1;
  p->x = -1;
  p->y = -1;
  p->wait = 0;
  p->hp = 1;
  p->enchant_type = 0;
  p->enchant_duration = 0;
  p->act = NULL;

  p->act = (int *) malloc(sizeof(int) * 4);
  if (p->act == NULL)
  {
    fprintf(stderr, "creature_new: malloc(p) failed\n");
    creature_delete(p);
    return NULL;
  }
  for (i = 0; i < 4; i++)
    p->act[i] = 0;

  return p;
}

void
creature_delete(creature *p)
{
  if (p == NULL)
    return;

  if (p->act != NULL)
  {
    free(p->act);
    p->act = NULL;
  }

  free(p);
  p = NULL;
}
