/* $Id: dungeon.h,v 1.54 2010/03/11 12:12:32 oohara Exp $ */

#ifndef __LOC_DUNGEON_H__
#define __LOC_DUNGEON_H__

#include "world.h"
#include "creature.h"
#include "list-int.h"
#include "object.h"

int distance(int ax, int ay, int bx, int by);
int compare_wait(list_int *p, list_int *q, void *data);
int has_los_from_player(world *wp, int z, int x, int y);
int add_creature_here(world *wp, creature *who, int n);
int add_creature(world *wp, creature *who);
int add_new_creature(world *wp, int type, int z, int x, int y, int wait);
int remove_creature(world *wp, int creature_id);
int creature_is_dead(world *wp, int creature_id);
int creature_is_friendly(world *wp, int creature_id);
int creature_is_face_to_face(world *wp, int creature_id);
int creature_take_damage(world *wp, int target_id, int dam,
                         int attacker_id, int verbose);
int creature_heal_hp(world *wp, int target_id, int amount, int verbose);
int creature_count_this_type(world *wp, int type);
int creature_change_xy(world *wp, int creature_id, int x, int y);
int creature_change_z(world *wp, int creature_id, int z);
int creature_teleport(world *wp, int creature_id);
int creature_add_enchantment(world *wp, int creature_id,
                             int type, int duration);
int add_object_here(world *wp, object *what, int n);
int add_object(world *wp, object *what);
int add_new_object(world *wp, int type, int z, int x, int y, int quantity);
int remove_object(world *wp, int object_id);
int object_is_dead(world *wp, int object_id);
int scroll_is_unknown(world *wp, int type);
char *scroll_name(world *wp, int type);
int add_inventory_here(world *wp, int type, int quantity, int n);
int add_inventory(world *wp, int type, int quantity);
int inventory_is_dead(world *wp, int inventory_id);
int count_inventory(world *wp);
int sort_inventory(world *wp, int how);
int inventory_find_this_type(world *wp, int type);
int grid_is_illegal(world *wp, int z, int x, int y);
int grid_blocks_creature(world *wp, int z, int x, int y);
int grid_has_creature(world *wp, int z, int x, int y);
int grid_blocks_los(world *wp, int z, int x, int y);
int grid_blocks_beam(world *wp, int z, int x, int y);
int find_stair_destination(world *wp,
                           int from_z, int from_x, int from_y,
                           int *dest_z, int *dest_x, int *dest_y);
int candle_is_in_the_last(world *wp);
int add_log(world *wp, const char *str);

#endif /* not __LOC_DUNGEON_H__ */
