/* $Id: scroll-detail.c,v 1.47 2010/03/12 14:24:07 oohara Exp $ */

#include <stdio.h>
/* rand */
#include <stdlib.h>

#include "scroll-detail.h"

int
scroll_detail_get(int type, struct scroll_detail *scd)
{
  if (scd == NULL)
  {
    fprintf(stderr, "scroll_detail_get: scd is NULL\n");
    return 1;
  }

  (*scd).type = type;
  switch (type)
  {
  case SC_TELEPORT:
    (*scd).real_name = "teleport";
    /* not healthy because you may move to the front of unknown enemies */
    (*scd).healthy = 0;
    (*scd).description = "It moves the target to a random location "
      "in this floor.";
    break;
  case SC_POISON:
    (*scd).real_name = "poison";
    (*scd).healthy = 0;
    (*scd).description = "It adds (4) poison to the target.";
    break;
  case SC_SPEED:
    (*scd).real_name = "speed";
    (*scd).healthy = 1;
    (*scd).description = "It adds (11) fast to the target.";
    break;
  case SC_SLOWNESS:
    (*scd).real_name = "slowness";
    (*scd).healthy = 0;
    (*scd).description = "It adds (10) slow to the target.\n"
      "It affects all creatures in line.";
    break;
  case SC_REGENERATION:
    (*scd).real_name = "regeneration";
    (*scd).healthy = 1;
    (*scd).description = "It adds (33) regenerate to the target.";
    break;
  case SC_MIGHT:
    (*scd).real_name = "might";
    (*scd).healthy = 1;
    (*scd).description = "It adds (13) might to the target.";
    break;
  case SC_WEAKNESS:
    (*scd).real_name = "weakness";
    (*scd).healthy = 0;
    (*scd).description = "It adds (12) weakness to the target.\n"
      "It affects all creatures in line.";
    break;
  case SC_REFLECTION:
    (*scd).real_name = "reflection";
    (*scd).healthy = 1;
    (*scd).description = "It adds (7) reflect to the target.";
    break;
  case SC_INVULNERABILITY:
    (*scd).real_name = "invulnerability";
    (*scd).healthy = 1;
    (*scd).description = "It adds (5) invulnerable to the target.";
    break;
  case SC_ANTIMAGIC:
    (*scd).real_name = "antimagic";
    /* useful if you fight against jelly */
    (*scd).healthy = 1;
    (*scd).description = "It adds (9) antimagic to the target.";
    break;
  case SC_STUNNING:
    (*scd).real_name = "stunning";
    (*scd).healthy = 0;
    (*scd).description = "It adds (4) stun to the target.";
    break;
  case SC_FEAR:
    (*scd).real_name = "fear";
    (*scd).healthy = 0;
    (*scd).description = "It adds (16) fear to the target.";
    break;
  case SC_LIGHTNING:
    (*scd).real_name = "lightning";
    (*scd).healthy = 0;
    (*scd).description = "It deals 12 damage to the target.\n"
      "It affects all creatures in line.";
    break;
  case SC_DETONATION:
    (*scd).real_name = "detonation";
    (*scd).healthy = 0;
    (*scd).description = "It deals 18 damage to the target and everything "
      "that is adjacent to it.\n"
      "Although it can't destroy walls, it can be targeted to a wall\n"
      "to damage monsters near the wall.";
    break;
  case SC_KNOWLEDGE:
    (*scd).real_name = "knowledge";
    (*scd).healthy = 1;
    (*scd).description = "If the target is yourself, you know all scrolls "
      "you are carrying.\n"
      "If the target is a monster or a wall, it maps the current floor.";
    break;
  default:
    (*scd).real_name = "undefined";
    (*scd).healthy = 0;
    (*scd).description = "It indicates this game has a bug.";
    break;
  }

  return 0;
}

int
random_scroll_type(int z)
{
  int type;

  type = rand() % NUM_SCROLL;
  switch (type)
  {
  case SC_INVULNERABILITY:
    if (rand() % 4 != 0)
    {
      if (rand() % 2 == 0)
        type = SC_REGENERATION;
      else
        type = SC_TELEPORT;
    }
    break;
  case SC_DETONATION:
    if (rand() % 2 == 0)
      type = SC_LIGHTNING;
    break;
  case SC_KNOWLEDGE:
    if (rand() % 2 == 0)
      type = SC_MIGHT;
    break;
  default:
    break;
  }

  return type;
}
