/* $Id: world.h,v 1.44 2010/03/11 09:11:58 oohara Exp $ */

#ifndef __LOC_WORLD_H__
#define __LOC_WORLD_H__

#include <curses.h>

#include "creature.h"
#include "list-int.h"
#include "object.h"
#include "inventory.h"

struct _world
{
  /* should be saved */
  int cr_size;
  creature **cr;
  int obj_size;
  object **obj;
  int size_z;
  int size_x;
  int size_y;
  int ***grid;
  int turn_z;
  list_int **turn_order;
  int player_id;
  int camera_z;
  int camera_x;
  int camera_y;
  int inv_size;
  inventory **inv;
  int label_size;
  int *label;
  int victory;
  int shadow_mode;
  int candle;
  int ut;
  /* not saved */
  WINDOW *scr;
  char *save_dir;
  int should_quit;
  int *mode;
  int cursor_x;
  int cursor_y;
  int log_size;
  char **log;
  int log_head;
};
typedef struct _world world;

world *world_new(void);
void world_delete(world *wp);
int world_init_curses(world *wp);
void world_reset_game(world *wp);
int world_expand_cr(world *wp);
int world_expand_obj(world *wp);
int world_expand_inv(world *wp);

#endif /* not __LOC_WORLD_H__ */
